#include "externalFunc.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <oci.h>

DLLIMPORT int sum(OCIExtProcContext* context,
                  char*  returnValue,
                  short* returnValue_ind,
                  int*   returnValue_len){
    
    //returnValue = (char*)OCIExtProcAllocCallMemory(context, 13);
    //returnValue[0] = '\0';
    strcat(returnValue,(char*)" ya quiero que salga");
    *returnValue_len = strlen(returnValue);
	*returnValue_ind = (short)OCI_IND_NOTNULL;
	return 0;
}

/*
 * Sum each value(dimension) in a vector
 */
DLLIMPORT double vecsum(char* str, short str_ind, int str_len, short* ret_ind){
    //double *items;// = OCIExtProcAllocCallMemory(ctx, 100);
    double sum = 0;
        
    if(str_ind == OCI_IND_NULL){
       *ret_ind = (short)OCI_IND_NULL;
       return;
    }else
       *ret_ind = (short)OCI_IND_NOTNULL;
    
    char* ptr;
    ptr=strtok(str,"|");
	while (ptr !=NULL){
		sum += (double)atof(ptr);
		ptr = strtok(NULL,"|");
	}
    /*
    char tmp[20];
    int i = 0;
    int j = 0;  
    while(i<(str_len)){
         if(str[i]!='|'){
            tmp[j] = str[i];
            j++;
        }else{
            tmp[j+1]='.';
            sum+=(float)atof(tmp);
            for(;j>=0;j--)
               tmp[j]='\0';
            j=0;
         }
         i++;
    }
    
    if(j>0){
       tmp[j+1]='.';
       sum+=(float)atof(tmp);
    }
    */
    return sum;
}

/*
 * Sum 2 vectors
 */
DLLIMPORT char* vecSum2(char* str1,      short str1_ind, int str1_len, 
                        char* str2,      short str2_ind, int str2_len,
                        short* ret_ind,  int*   ret_len, int*   ret_maxlen){
    
    char buffer[MAX_STR_LEN]="";
    //*ret_maxlen = MAX_STR_LEN;
    
    if(str1_ind == OCI_IND_NULL || str2_ind == OCI_IND_NULL){
       *ret_ind = (short)OCI_IND_NULL;
       return buffer;
    }else
       *ret_ind = (short)OCI_IND_NOTNULL;
    
    double a[MAX_D];
    double b[MAX_D];
    double c[MAX_D];
    int sizeA, sizeB;
    int i;
    //Desempaquetar vectores y validar que tienen la misma dimensin
    split(str1,a,&sizeA);
    split(str2,b,&sizeB);
    if(sizeA != sizeB || sizeA>MAX_D || sizeB>MAX_D){
       *ret_ind = (short)OCI_IND_NULL;
       return buffer;   
    }
    for(i=0;i<sizeA;i++)
       c[i] = a[i]+b[i];
    
    join(c, &sizeA, buffer);
    *ret_len = strlen(buffer);
    
	return buffer;
}

/*
 * Vector product scalar
 */
DLLIMPORT char* vecProdScalar(char*   str1,   short str1_ind, int str1_len, 
                              double* val,    short val_ind, 
                              short* ret_ind, int*  ret_len,  int*   ret_maxlen){
    
    char buffer[MAX_STR_LEN]="";
    //*ret_maxlen = MAX_STR_LEN;
    
    if(str1_ind == OCI_IND_NULL || val_ind == OCI_IND_NULL){
       *ret_ind = (short)OCI_IND_NULL;
       return buffer;
    }else
       *ret_ind = (short)OCI_IND_NOTNULL;
    
    double a[MAX_D];
    double c[MAX_D];
    int sizeA;
    int i;
    //Desempaquetar vectore y validar 
    split(str1,a,&sizeA);

    if(sizeA>MAX_D ){
       *ret_ind = (short)OCI_IND_NULL;
       return buffer;   
    }
    for(i=0;i<sizeA;i++)
       c[i] = a[i]*(*val);
    
    join(c, &sizeA, buffer);
    *ret_len = strlen(buffer);
    
	return buffer;
}
/*
 * Producto punto de 2 vectores
 */
DLLIMPORT double dotProduct(char* str1, short str1_ind, int str1_len, 
                            char* str2, short str2_ind, int str2_len, short *ret_ind){
    double sum = 0;
    
    if(str1_ind == OCI_IND_NULL || str2_ind == OCI_IND_NULL){
       *ret_ind = (short)OCI_IND_NULL;
       return;
    }else
       *ret_ind = (short)OCI_IND_NOTNULL;
    
    //Validacin de que los vectores tengan la misma dimensin
    
    char tmp1[20];
    char tmp2[20];
    int i1 = 0;
    int i2 = 0;
    int j1 = 0;
    int j2 = 0;  
    double v1=0;
    double v2=0;
    
    while(i1<(str1_len) || i2<(str2_len)){
         //Extraer valor de str1
         while(1){
            v1 = 0;
            if(i1 >= str1_len) break;
            if(str1[i1] != '|'){
               tmp1[j1] = str1[i1];
               j1++;
            }else{
               tmp1[j1+1] = '.';
               v1 = (double)atof(tmp1);
               for(;j1>=0;j1--)
                  tmp1[j1] = '\0';
               j1 = 0;
               i1++;
               break;   
            }
            i1++;
         }
         //Extraer valor de str2
         while(1){
            v2 = 0;
            if(i2 >= str2_len) break;
            if(str2[i2] != '|'){
               tmp2[j2] = str2[i2];
               j2++;
            }else{
               tmp2[j2+1] = '.';
               v2 = (double)atof(tmp2);
               for(;j2>=0;j2--)
                  tmp2[j2] = '\0';
               j2 = 0;
               i2++;
               break;  
            }
            i2++;
         }
         sum += (v1*v2);
    }
    
    if(j1>0 || j2>0){
       tmp1[j1+1]='.';
       tmp2[j2+1]='.';
       v1 = (double)atof(tmp1);
       v2 = (double)atof(tmp2);
       sum += (v1*v2);
    }
	
	return sum;
}

DLLIMPORT double dotProduct2(char* str1, short str1_ind, int str1_len, 
                             char* str2, short str2_ind, int str2_len, short *ret_ind){
    double sum = 0;
    
    if(str1_ind == OCI_IND_NULL || str2_ind == OCI_IND_NULL){
       *ret_ind = (short)OCI_IND_NULL;
       return 0;
    }else
       *ret_ind = (short)OCI_IND_NOTNULL;
    
    double a[MAX_D];
    double b[MAX_D];
    int sizeA, sizeB;
    int i;
    //Desempaquetar vectores y validar que tienen la misma dimensin
    split(str1,a,&sizeA);
    split(str2,b,&sizeB);
    if(sizeA != sizeB || sizeA>MAX_D || sizeB>MAX_D){
       *ret_ind = (short)OCI_IND_NULL;
       return 0;   
    }
    for(i=0;i<sizeA;i++)
       sum += a[i]*b[i];

	return sum;
}
/*
 * Distancia Euclidiana entre 2 vectores
 */
DLLIMPORT double euclidianDist(char* str1, short str1_ind, int str1_len, 
                               char* str2, short str2_ind, int str2_len, short *ret_ind){
    double dist = 0;
    
    if(str1_ind == OCI_IND_NULL || str2_ind == OCI_IND_NULL){
       *ret_ind = (short)OCI_IND_NULL;
       return;
    }else
       *ret_ind = (short)OCI_IND_NOTNULL;
    
    //Validacin de que los vectores tengan la misma dimensin
    
    char tmp1[20];
    char tmp2[20];
    int i1 = 0;
    int i2 = 0;
    int j1 = 0;
    int j2 = 0;  
    double v1=0;
    double v2=0;
    
    while(i1<(str1_len) || i2<(str2_len)){
         //Extraer valor de str1
         while(1){
            v1 = 0;
            if(i1 >= str1_len) break;
            if(str1[i1] != '|'){
               tmp1[j1] = str1[i1];
               j1++;
            }else{
               tmp1[j1+1] = '.';
               v1 = (double)atof(tmp1);
               for(;j1>=0;j1--)
                  tmp1[j1] = '\0';
               j1 = 0;
               i1++;
               break;   
            }
            i1++;
         }
         //Extraer valor de str2
         while(1){
            v2 = 0;
            if(i2 >= str2_len) break;
            if(str2[i2] != '|'){
               tmp2[j2] = str2[i2];
               j2++;
            }else{
               tmp2[j2+1] = '.';
               v2 = (double)atof(tmp2);
               for(;j2>=0;j2--)
                  tmp2[j2] = '\0';
               j2 = 0;
               i2++;
               break;  
            }
            i2++;
         }
         dist += (v1-v2)*(v1-v2);
    }
    
    if(j1>0 || j2>0){
       tmp1[j1+1]='.';
       tmp2[j2+1]='.';
       v1 = (double)atof(tmp1);
       v2 = (double)atof(tmp2);
       dist += (v1-v2)*(v1-v2);
    }
	
	return dist;
}

/*
 * No. Argumento(dimensin) menor en un vector
 */
DLLIMPORT int argmin(char* str, short str_ind, int str_len, short *ret_ind){
    int l = 0;
    int argMin = 0;
    double valMin = 0;
    
    if(str_ind == OCI_IND_NULL){
       *ret_ind = (short)OCI_IND_NULL;
       return;
    }else
       *ret_ind = (short)OCI_IND_NOTNULL;
       
    char* ptr;
    ptr=strtok(str,"|");
    
    if(ptr != NULL){
        l++;
        argMin = l;
        valMin = (double)atof(ptr);
        ptr = strtok(NULL,"|");      
    }
    
	while (ptr !=NULL){
        l++;
		if(((double)atof(ptr)) < valMin)
           argMin=l;
		ptr = strtok(NULL,"|");
	}
    return argMin;
}
/*
 * No. Argumento(dimensin) mayor en un vector
 */
DLLIMPORT int argmax(char* str, short str_ind, int str_len, short *ret_ind){
    int l = 0;
    int argMax = 0;
    double valMax = 0;
    
    if(str_ind == OCI_IND_NULL){
       *ret_ind = (short)OCI_IND_NULL;
       return;
    }else
       *ret_ind = (short)OCI_IND_NOTNULL;
       
    char* ptr;
    ptr=strtok(str,"|");
    
    if(ptr != NULL){
        l++;
        argMax = l;
        valMax = (double)atof(ptr);
        ptr = strtok(NULL,"|");      
    }
    
	while (ptr !=NULL){
        l++;
		if(((double)atof(ptr)) > valMax)
           argMax=l;
		ptr = strtok(NULL,"|");
	}
    return argMax;
}

void split(char* str, double* arr, int* size){
    int i,l = 0;
    
    char* ptr;
    ptr=strtok(str,"|");
    
	while (ptr !=NULL){
        if(l<MAX_D)
           arr[l] = (double)atof(ptr);
		l++;
		ptr = strtok(NULL,"|");
	}
	*size = l;
	
	//Limpiar posiciones restantes
    //for(i=l;i<MAX_D;i++)
    //    arr[i]=0;
}

void join(double* arr, int* size, char* str){
     char buffer[500];
     int i,j;
     strcpy(str,(char*)"");
     for(i=0;i<*size;i++){
         sprintf(buffer,"%f",arr[i]);
         j = strlen(buffer)-1;
         while((buffer[j]=='0'||buffer[j]=='.')){
            if(buffer[j]=='.'){
               buffer[j]='\0';
               break;
            }
            buffer[j]='\0';
            j--;
         }
         if(i!=0)
            strcat(str,(char *)"|");
         strcat(str,buffer);
     }
}

